
var shortKey = '';
var journeyDetails;
var busMarkerPosition;
var mapData;
var poly;
var busMarker;
var etaDetails;
var firstLoad;
var firstLoad_pickup;
var markers = [];
var mapView = 'minimized';
var map;
var markerCluster;
var pickDropMarkers = [];
var clearBusmarker;
var all_stages = [];
var etaInterval;
var prev_coords;
var current_latLng;
var busIcon = L.icon({
    iconUrl: "<%=asset_path('bus.png') %>"
}) 
document.addEventListener("DOMContentLoaded", function (event) {
    //.setView([20.5937, 78.9629], 30);
    var enc = decodeURIComponent(location.href);
    if (enc && enc.split('?')[1]) {
        shortKey = enc.split('?')[1];
        getJourneyDetails(shortKey);
    }
    else {
        //console.log('das', enc.split('?')[1]);
        document.getElementById('error').style.display = 'block';
        document.getElementById('container').innerHTML = '<div class="container-error"><div>' + 'Service Unavailable' + '</div></div>';
    }

    var blurDate;
    window.addEventListener('focus', function () {
        if (blurDate) {
            if ((new Date().getTime() - blurDate.getTime()) / 1000 >= 60) {
                blurDate = new Date();
            }
        }
    });
    window.addEventListener('blur', function () {
        blurDate = new Date()
        //console.log('blur');
    });

});

function getJourneyDetails() {
    try {
        document.getElementById('loader').classList.add('loading');
        URL = 'http://bus.trackingo.in/api/live/journey_details?key=' + shortKey + '&zoom_position=12&platform=' + 'mobile';  //Your URL
        var xhr = new XMLHttpRequest();
        xhr.open("GET", URL, true);
        xhr.onload = function (e) {

            if (xhr.readyState === 4) {
                if (xhr.status === 200) {

                    var jsonRes = JSON.parse(xhr.responseText);
                    console.log(jsonRes);
                    if (jsonRes.status == 200) {
                        journeyDetails = jsonRes.journey_details;
                        mapData = jsonRes.track_customer;
                        all_stages = jsonRes.all_service_places;
                        document.getElementById('loaded').style.display = 'block';
                        var dynamic = '<div class="header-logo">' +
                            '<div class="operator-logo-icon">' +
                            '<div class="op-logo">' +
                            '<div>' + journeyDetails.operator_name + '</div>' +
                            '</div>' +
                            '<div class="tr-icon">' +
                            '<img src="<%=asset_path "trackingo-icon.png"%>"/>' +
                            '</div>' +
                            '</div>' +
                            '</div>' +
                            '<div class="tag-line">Trackingo for Your Safety & Comfort</div>' +
                            '<div class="journey-details">' +
                            '<div class="label-container">' +
                            '<div class="left"><span class=""><b> Service:</b></span> <span>' + journeyDetails.service_number + '</span></div>' +
                            '<div class="right"><i class="fa fa-bus"></i> <span>' + journeyDetails.vehicle_number + '</span></div>' +
                            '<div class="clear"></div>' +
                            '</div>' +
                            '<div class="label-container">' +
                            '<div class="left boarding"><i class="fa fa-map-marker"></i><span>' + journeyDetails.boarding_at + '</span></div>' +
                            '<div class="right boarding"><i class="fa fa-clock-o"></i> <span>' + journeyDetails.boarding_time + '</span></div>' +
                            '<div class="clear"></div>' +
                            '</div>' +

                            '<div class="info">' + journeyDetails.boarding_address + '</div>' +
                            '</div>' +
                            '<div class="request-div">' +
                            '<div class="direction-container">' +
                            '<div class="border-right direction">' +
                            '<div tappable onclick="getDirections()">' +
                            '<span><i class="fa fa-location-arrow"></i></span> <span>Directions</span>' +
                            '</div>' +
                            '</div>' +
                            '<div class="request-btn" onclick="requestChange()">' +
                            '<div>Now you can raise request for toilet stops and more!</div>' +
                            '</div>' +
                            '<div class="border-left panic" onclick="raisePanicRequest()">' +
                            '<span><i class="fa fa-bullhorn"> </i> Panic</span>' +
                            '</div>' +
                            '</div>' +
                            ' </div>'
                        document.getElementById('journeyDetails').innerHTML = dynamic;
                        //document.getElementById('map-container').style.display = 'block';
                        document.getElementById('footer').style.display = 'block';
                        if (navigator.userAgent.match(/(iPad|iPhone|iPod)/g))
                            document.getElementById('os').className = 'fa fa-apple';
                        else
                            document.getElementById('os').className = 'fa fa-android';
                        loadMap();
                        getEtaDetails();
                        etaInterval = setInterval(function () {
                            getEtaDetails();
                        }, 20000);
                    } else {
                        document.getElementById('error').style.display = 'block';
                        document.getElementById('loaded').style.display = 'none';
                        if (jsonRes.status == 302) {
                            if (jsonRes.message) {
                                document.getElementById('container').innerHTML = '<div class="container-error"><div>' + jsonRes.message + '</div></div>';
                            } else {
                                errorMessage = jsonRes.track_customer;
                                document.getElementById('container').innerHTML = '<div class="container-error"><div>' + jsonRes.track_customer + '</div></div>';
                            }
                        } else {
                            document.getElementById('container').innerHTML = '<div class="container-error"><div>' + jsonRes.message + '</div></div>';
                        }
                        document.getElementById('loader').classList.remove('loading');
                    }

                } else {
                    console.error(xhr.statusText);
                }
            }

        };
        xhr.onerror = function (e) {
            console.error(e.statusText);
            document.getElementById('loader').classList.remove('loading');
            document.getElementById('error').style.display = 'block';
            document.getElementById('container').innerHTML = '<div class="container-error"><div>' + 'Something is Technically Wrong, We are going to fix it up and things will be normal soon.' + '</div></div>';
        };
        xhr.send(null);
    } catch (e) {
        console.log('crash');
        document.getElementById('loader').classList.remove('loading');
        document.getElementById('error').style.display = 'block';
        document.getElementById('container').innerHTML = '<div class="container-error"><div>' + 'Something is Technically Wrong, We are going to fix it up and things will be normal soon.' + '</div></div>';
    }
}

function raisePanicRequest() {
   var r=confirm("Are you sure you want to raise panic request?")
   var pageURL = $(location).attr("href").split("?"); 
   if (r==true && pageURL.length == 2)
   {    
    $.ajax({
    url: 'http://bus.trackingo.in/api/tracking/panic_details?short_code='+pageURL[1]+'&from_webApp=true' ,
    format: 'script',
    type: 'GET',
    success: function(data) { 
        if (data['code'] == 200){
            alert("Panic request successfully raised.");            
        }
        else
        {
            alert("Panic request failed.");
        }
    },
    error: function(e) {
      alert(e)
      console.log(e)
    }
   });    
   }
}

function getEtaDetails() {
    try {
        URL = 'http://bus.trackingo.in/api/live/eta_map?current_status=true&key=' + shortKey, null;
        var xhr = new XMLHttpRequest();
        xhr.open("GET", URL, true);
        xhr.onload = function (e) {
            if (xhr.readyState === 4) {
                if (xhr.status === 200) {

                    var jsonRes = JSON.parse(xhr.responseText);
                    console.log(jsonRes);
                    if (jsonRes.status == 200) {
                        document.getElementById('loader').classList.remove('loading');
                        etaDetails = jsonRes;
                        getCurrentIndex();
                        if (etaDetails && etaDetails.eta_map_data.length > 0) {
                            document.getElementById('eta').style.display = 'flex';
                            var etaStages = '<ol>';
                            for (var i = 0; i < etaDetails.eta_map_data.length; i++) {
                                var point = etaDetails.eta_map_data[i];
                                var stage = '<li>';
                                if (i == etaDetails.eta_map_data.length - 1 && etaDetails.distance_details.boarding_id == point.id) {
                                    stage = '<li class="last dotted">'
                                } else {
                                    if (i == etaDetails.eta_map_data.length - 1) {
                                        stage = '<li class="last">'
                                    }
                                    if (etaDetails.distance_details.boarding_id == point.id) {
                                        stage = '<li class="dotted">'
                                    }
                                }
                                if (i != etaDetails.eta_map_data.length - 1 && point.id == etaDetails.current_sp_id) {
                                    stage += '<div class="bus" id="current-loc" style="left:' + (etaDetails.is_passed ? '55%' : '20%') + '" >' +
                                        '<div class="bus-img">' +
                                        '<i class="fa fa-bus"></i>' +
                                        '</div>' +
                                        '</div >';
                                }
                                stage += '<div class="point" style = "background:' + getColor(point.color) + '" >' +
                                    '<i class="' + getStageIcon(point, i) + '"></i>' +
                                    '</div>' +
                                    '<div class="description">' +
                                    '<div class="boarding">' + point.service_place_name + ' </div>' +
                                    '<span>' + getDescText(point, i) + '</span>' +
                                    ' </div>' + '</li>'
                                etaStages += stage;
                            }
                            etaStages += '</ol>';
                            document.getElementById('eta').innerHTML = etaStages;
                            if (etaDetails.eta_pickup_data.length > 0){
                            document.getElementById('eta_pickup').style.display = 'flex';
                            var pickup_etaStages = '<span style="width: 120px;margin-left: 10px;"> '+ etaDetails.stt_pickup_asset_name + ' (Pickup)' + '</span><ol style="margin-left: 120px;">';
                            document.getElementById('eta_pickup').style.display = '';
                            getCurrentIndex_pickup()
                            console.log(firstLoad_pickup)
                            for (var i = 0; i < etaDetails.eta_pickup_data.length; i++) {
                                var point = etaDetails.eta_pickup_data[i];
                                var stage = '<li>';
                                if (i == etaDetails.eta_pickup_data.length - 1 && etaDetails.distance_details.boarding_id == point.id) {
                                    stage = '<li class="last dotted">'
                                } else {
                                    if (i == etaDetails.eta_pickup_data.length - 1) {
                                        stage = '<li class="last">'
                                    }
                                    if (etaDetails.distance_details.boarding_id == point.id) {
                                        stage = '<li class="dotted">'
                                    }
                                }
                                
                                if (point.id == etaDetails.last_crossed_pickup) {
                                    stage += '<div class="bus" id="current-loc1" style="left:' + (etaDetails.is_passed_pickup ? '55%' : '20%') + '" >' +
                                        '<div class="bus-img">' +
                                        '<i class="fa fa-bus"></i>' +
                                        '</div>' +
                                        '</div >';
                                }
                                stage += '<div class="point" style = "background:' + getColor(point.color) + '" >' +
                                    '<i class="' + getStageIcon_pickup(point, i) + '"></i>' +
                                    '</div>' +
                                    '<div class="description">' +
                                    '<div class="boarding">' + point.service_place_name + ' </div>' +
                                    '<span>' + getDescText_pickup(point, i) + '</span>' +
                                    ' </div>' + '</li>'
                                pickup_etaStages += stage;
                            }
                            pickup_etaStages += '</ol>';
                            document.getElementById('eta_pickup').innerHTML = pickup_etaStages;
                            }
                            setTimeout(function () {
                               scrollETA();
                            }, 10);
                        }


                    }
                    if (etaDetails.current_status_details)
                        getBusMarker(etaDetails.current_status_details);
                    // if (busMarker) {
                    //     var latLng = busMarker.getPosition(); // returns LatLng object
                    //     map.setCenter(latLng);
                    // }
                } else {
                    document.getElementById('loader').classList.remove('loading');
                }

            } else {
                console.error(xhr.statusText);
                document.getElementById('loader').classList.remove('loading');
            }
        };
        xhr.onerror = function (e) {
            console.error(e.statusText);
            document.getElementById('loader').classList.remove('loading');
        };
        xhr.send(null);
    } catch (e) {
        document.getElementById('loader').classList.remove('loading');
    }
}
function getCurrentIndex() {
    for (var i = 0; i < etaDetails.eta_map_data.length; i++) {
        if (etaDetails.eta_map_data[i].id === etaDetails.current_sp_id) {
            firstLoad = i;
            break;
        }
    }
}

function getCurrentIndex_pickup() {
    for (var i = 0; i < etaDetails.eta_pickup_data.length; i++) {
        if (etaDetails.eta_pickup_data[i].id === etaDetails.last_crossed_pickup) {
            firstLoad_pickup = i;
            break;
        }
    }
}

function getBusMarker(current_status_details) {
var geocodeService = L.esri.Geocoding.geocodeService();    
current_latLng = current_status_details["lat_long"]; // returns LatLng object
// if (busMarker){
//     mymap.removeLayer(busMarker)     
// }
// if (prev_coords && prev_coords[0] != current_latLng[0] && prev_coords[1] != current_latLng[1]){
//     busMarker = L.Marker.movingMarker([prev_coords,current_latLng],[20000]).addTo(mymap);
//     mymap.panTo(busMarker.getLatLng()); 
//     prev_coords = current_latLng
// }
// else{
//     busMarker = L.Marker.movingMarker([current_latLng,current_latLng],[20000]).addTo(mymap);
//     mymap.panTo(busMarker.getLatLng()); 
//     prev_coords = current_latLng
// }
// busMarker.start();
//mymap.removeLayer(busMarker) 


// if (busMarker != null) 
// {
//     busMarker.setLatLng(current_latLng).update()
// }       
// else
// {
//     busMarker = L.marker(current_latLng, {icon: busIcon}).addTo(mymap)
// }

if (busMarker != null) 
{
    if(prev_coords != null && prev_coords[0] != current_latLng[0] && prev_coords[1] != current_latLng[1]){
        mymap.removeLayer(busMarker)
        busMarker =  L.Marker.movingMarker([prev_coords,current_latLng],[20000],{icon: busIcon}).addTo(mymap);
        busMarker.start()
    }
    else
    {
        busMarker.setLatLng(current_latLng).update()        
    }
}       
else
{
    busMarker = L.marker(current_latLng, {icon: busIcon}).addTo(mymap)
}
prev_coords = current_latLng
var content = ""
if(current_status_details['details']['location'] != null){
    content += "<b>Location: </b>"+current_status_details['details']['location']+"</br><b>Time: </b>"+current_status_details['details']["timestamp"]+"</br><b>Speed: </b>"+ current_status_details['details']['speed'] +" km/h</br>" + 'Check more details <a target= "_blank" href="https://www.google.com/maps/search/?api=1&query='+current_latLng[0]+','+current_latLng[1]+'&markers=icon:http://image.ibb.co/dWFHaw/bus.png">here</a>'
    busMarker.bindPopup(content)
}
else{
    geocodeService.reverse().latlng(current_latLng).run(function(error, result) { 
        content += "<b>Location: </b>"+result.address.Match_addr+"</br><b>Time: </b>"+current_status_details['details']["timestamp"]+"</br><b>Speed: </b>"+ current_status_details['details']['speed'] +" km/h</br>" + 'Check more details <a target= "_blank" href="https://www.google.com/maps/search/?api=1&query='+current_latLng[0]+','+current_latLng[1]+'&markers=icon:http://image.ibb.co/dWFHaw/bus.png">here</a>'
        busMarker.bindPopup(content)
    })
}
//busMarker = L.Marker.movingMarker([latLng,latLng],[20000]).addTo(mymap);
mymap.panTo(new L.LatLng(current_latLng[0],current_latLng[1]));
if (!busMarkerPosition) {
busMarkerPosition = {
    lat: current_status_details.lat_long[0],
    long: current_status_details.lat_long[1]
}
}
// if (prev_coords != current_status_details.lat_long){

// console.log("dfkjbdsjfb");
// console.log(prev_coords);

// console.log([current_status_details.lat_long[0], current_status_details.lat_long[1]]);
// console.log("dfkjbdsjfb1");
// busMarker = L.Marker.movingMarker([prev_coords,[current_status_details.lat_long[0], current_status_details.lat_long[1]]],[20000]).addTo(mymap);
// busMarker.start();
// mymap.panTo(busMarker.getLatLng());
// }
//moveBus(current_status_details);
//mymap.flyTo(latLng, 16)
    // try {
    //     if (current_status_details) {
    //         if (!busMarkerPosition) {
    //             busMarkerPosition = {
    //                 lat: current_status_details.lat_long[0],
    //                 long: current_status_details.lat_long[1]
    //             }
    //             if (mapData.length > 0) {
    //                 if (mapData[mapData.length - 1].origin[0] == current_status_details.lat_long[0] && mapData[mapData.length - 1].origin[1] == current_status_details.lat_long[1]) {

    //                 } else if (poly) {
    //                     var path = poly.getPath();
    //                     path.push(new google.maps.LatLng(current_status_details.lat_long[0], current_status_details.lat_long[1]));
    //                 }
    //             }
    //         }
    //         if (!busMarker) {
    //             busMarker = new google.maps.Marker({
    //                 position: new google.maps.LatLng(current_status_details.lat_long[0], current_status_details.lat_long[1]),
    //                 center: new google.maps.LatLng(current_status_details.lat_long[0], current_status_details.lat_long[1]),
    //                 map: map,
    //                 icon: "<%#=asset_path 'bus.png'%>",
    //                 animation: google.maps.Animation.DROP,
    //                 zIndex: 10000
    //             });
    //         } else {
    //             moveBus(current_status_details);
    //         }
    //     }
    // } catch (e) {
    //     console.log(e);
    // }
}
function loadMap() {
    // if (mapData) {
    //     var ele = document.getElementById('map');
    //     var map_options = {
    //         zoom: 14,
    //         mapTypeId: google.maps.MapTypeId.ROADMAP,
    //         draggable: false,
    //         zoomControl: false,
    //         scrollwheel: false,
    //         disableDoubleClickZoom: true,
    //         clickableIcons: false,
    //         fullscreenControl: !navigator.userAgent.match(/(iPad|iPhone|iPod)/g)
    //     };
    //     map = new google.maps.Map(ele, map_options);
    //     drawPolyLine();
    //     if (navigator.userAgent.match(/(iPad|iPhone|iPod)/g)) {
    //         addFullScrrenControl();
    //     } else {
    //         mapViewChange();
    //     }

    // }
}
function moveBus(res) {
    try {
        if (busMarkerPosition) {
            var i = 0;
            var deltaLat;
            var deltaLng;
            i = 0;
            deltaLat = parseFloat(((res.lat_long[0] - busMarkerPosition.lat) / 100).toFixed(10));
            deltaLng = parseFloat(((res.lat_long[1] - busMarkerPosition.long) / 100).toFixed(10));
            if (deltaLat == 0 && deltaLng == 0) return;
            //moveMarker(deltaLat, deltaLng, i, res);
            // debugger;
            console.log(res);
             var prev_coords = [busMarker.getLatLng()['lat'],busMarker.getLatLng()['lng']]
             mymap.removeLayer(busMarker)             
            busMarker = L.Marker.movingMarker([[23.211762,77.377276],[23.254037, 77.425341]],[20000]).addTo(mymap);
            busMarker.start();
            mymap.panTo(busMarker.getLatLng());
        }
    } catch (e) {
        console.log(e);
    }
}
function drawPolyLine() {
    var path = [];
    for (var i = 0; i < mapData.length; i++) {
        path.push(new google.maps.LatLng(mapData[i].origin[0], mapData[i].origin[1]));
    }
    poly = new google.maps.Polyline({
        path: path,
        strokeColor: '#488AFF',
        strokeOpacity: 1.0,
        strokeWeight: 0
    });
    poly.setMap(map);
}

function addFullScrrenControl() {
    map.controls[google.maps.ControlPosition.RIGHT_TOP].push(
        FullScreenControl(map));

}

function moveMarker(deltaLat, deltaLng, i, data) {
            //debugger;
    try {
        if (busMarkerPosition && busMarker) {
            prev_coords = [busMarker.getLatLng()['lat'],busMarker.getLatLng()['lng']]
            // if (busMarker != null){
            //  mymap.removeLayer(busMarker)
            // }
            busMarkerPosition.lat += deltaLat;
            busMarkerPosition.long += deltaLng;
            // busMarker = L.marker([busMarkerPosition.lat,busMarkerPosition.long], {icon: busIcon}).addTo(mymap)
            mymap.removeLayer(busMarker)                     
            if ((i % 50) == 0)
                busMarker = L.Marker.movingMarker([prev_coords,[busMarkerPosition.lat, busMarkerPosition.long]],[20000]).addTo(mymap);
                busMarker.start();
                mymap.panTo(busMarker.getLatLng());
            if (i != 100) {
                i++;
                //busMarker.setPosition(new google.maps.LatLng(busMarkerPosition.lat, busMarkerPosition.long));
                // busMarker = null
                
                // busMarker = L.marker([busMarkerPosition.lat,busMarkerPosition.long], {icon: busIcon}).addTo(mymap)
                // busMarker.setLatLng([busMarkerPosition.lat, busMarkerPosition.long]).update()
                
                //mymap.panTo([busMarkerPosition.lat, busMarkerPosition.long]);
                busMarker = L.Marker.movingMarker([prev_coords,[busMarkerPosition.lat, busMarkerPosition.long]],[20000]).addTo(mymap);
                busMarker.start();
                mymap.panTo(busMarker.getLatLng());
                // setTimeout(function () {
                //     moveMarker(deltaLat, deltaLng, i, data);
                //     //debugger;
                // }, 200);
            } else {
                busMarkerPosition.lat = data.lat_long[0];
                busMarkerPosition.long = data.lat_long[1];
                mapData.push({
                    origin: data.lat_long,
                    destination: data.lat_long,
                    details: data.details
                })
                //busMarker.setPosition(new google.maps.LatLng(busMarkerPosition.lat, busMarkerPosition.long));
                busMarker.setLatLng([busMarkerPosition.lat, busMarkerPosition.long])
                mymap.panTo(busMarker.getLatLng());
                // if (poly && mapView == 'maximized') {
                //     var path = poly.getPath();
                //     path.push(new google.maps.LatLng(busMarkerPosition.lat, busMarkerPosition.long));
                // }
            }
        }
    } catch (e) {
        console.log(e);
    }
}







function addmarkers() {
    var bounds = new google.maps.LatLngBounds();
    var incrementCount = 1;
    if (mapData.length > 0) {
        incrementCount = parseInt(Math.round(mapData.length / 300) + '');
        incrementCount = incrementCount > 0 ? incrementCount : 1;
    }

    for (var i = 0; i < mapData.length; i = i + incrementCount) {
        var marker = new google.maps.Marker({
            position: new google.maps.LatLng(mapData[i].origin[0], mapData[i].origin[1]),
            map: map,
            icon: "<%=asset_path "red-dot.png"%>"
        });
        markers.push(marker);
        var content = "<p>" + mapData[i].details.timestamp + "</p></p>" + mapData[i].details.speed + " km/hr" + "</p>";
        addInfoWindow(marker, content);
    }
    addPickDropMarkers(all_stages);
    markerCluster = new MarkerClusterer(map, markers, {
        styles: [
            {
                textColor: 'white',
                url: "<%=asset_path "red-dot.png"%>",
                height: 15,
                width: 15
            },
            {
                textColor: 'white',
                url: "<%=asset_path "red-dot.png"%>",
                height: 15,
                width: 15
            },
            {
                textColor: 'white',
                url: "<%=asset_path "red-dot.png"%>",
                height: 15,
                width: 15
            }
        ]
    })
}
function clearMap() {
    for (var i = 0; i < markers.length; i++) {
        markers[i].setMap(null);
    }
    markers = [];
    if (markerCluster) {
        markerCluster.clearMarkers();
    }
    for (var stage in pickDropMarkers) {
        pickDropMarkers[stage].setMap(null);
    }
    pickDropMarkers = [];
    map.controls[google.maps.ControlPosition.LEFT_BOTTOM].clear();
    if (busMarker) {
        var latLng = busMarker.getPosition();
        map.setCenter(latLng);
    }
}

function addInfoWindow(marker, content) {

    var infoWindow = new google.maps.InfoWindow({
        content: content
    });

    google.maps.event.addListener(marker, 'click', function () {
        infoWindow.open(map, marker);
    });

}

function feedback(type) {
    document.getElementById('track').style.display = 'none';
    var modal = document.getElementById('myModal');
    modal.style.display = "block";

    modal.classList.add('animate');
    if (type == 2) {
        document.getElementById('tracking').style.display = 'block';
        document.getElementById('operator').style.display = 'none';
    } else {
        document.getElementById('operator').style.display = 'block';
        document.getElementById('tracking').style.display = 'none';

    }

    var span = document.getElementsByClassName("close")[0];

    var submit = document.getElementById("submitFeed");

    submit.onclick = function () {
        if (type == 2) {
            var rate = getSelectedValue("rate");
            if (rate && rate != '') {
                submitFeed({
                    type: 2,
                    rating: rate,
                    feature_request: document.getElementById('featureRequest').value,
                    feedback: document.getElementById('feedback').value
                }, modal);
            } else {
                showToast('Please Enter the details');
            }
        } else {
            var pick_exe = getSelectedValue("pick_exe");
            var bus_qty = getSelectedValue("bus_qty");
            var staff_bhe = getSelectedValue("staff_bhe");
            var amenities = getSelectedValue("amenities");
            var drop_exe = getSelectedValue("drop_exe");
            var recommand = getSelectedValue("recommand");
            if (pick_exe && pick_exe != '' && bus_qty && bus_qty != '' && staff_bhe && staff_bhe != '' && drop_exe && drop_exe != ''
                && amenities && amenities != '' && recommand && recommand != '') {
                submitFeed({
                    type: 1,
                    pickup_exp: pick_exe,
                    bus_quality: bus_qty,
                    staff_behavior: staff_bhe,
                    amenities: amenities,
                    recommend: recommand,
                    drop_exp: drop_exe,
                    feedback: document.getElementById('suggestion').value
                }, modal)
            } else {
                showToast('Please Enter the details');
            }
        }
    }
    span.onclick = function () {
        closeModal(modal)
    }
    window.onclick = function (event) {
        if (event.target == modal) {
            closeModal(modal);
        }
    }
}

function closeModal(modal) {
    modal.classList.remove('animate');
    clearModalValues();
    modal.style.display = "none";
    document.getElementById('track').style.display = 'block';
}
function clearModalValues() {
    document.getElementById('featureRequest').value = '';
    document.getElementById('feedback').value = '';
    document.getElementById('suggestion').value = '';
    clearSelectedValue('rate');
    clearSelectedValue("pick_exe");
    clearSelectedValue("bus_qty");
    clearSelectedValue("staff_bhe");
    clearSelectedValue("amenities");
    clearSelectedValue("drop_exe");
    clearSelectedValue("recommand");
}
function clearSelectedValue(name) {
    var vals = document.getElementsByName(name);
    for (var val in vals) {
        vals[val].checked = false;
    }
}
function getSelectedValue(name) {
    var vals = document.getElementsByName(name);
    for (var val in vals) {
        if (vals[val].checked) return vals[val].value;
    }
    return '';
}
function getColor(color) {
    var colorValue = ''
    switch (color) {
        case "color_gray": colorValue = '#666'; break;
        case "color_green": colorValue = '#009600'; break;
        case "color_red": colorValue = 'red'; break;
        case "color_yellow": colorValue = '#ff9d0a'; break;
        default: colorValue = '#666'; break;
    }
    return colorValue;
}

function addPickDropMarkers(stages) {
    try {
        for (var stage in stages) {
            var marker = new google.maps.Marker({
                position: new google.maps.LatLng(stages[stage].lat_long[0], stages[stage].lat_long[1]),
                map: map,
                icon: (stages[stage].stage_type == 'boarding')? "<%=asset_path 'pick.png'%>" : "<%=asset_path 'drop.png'%>"
            });
            pickDropMarkers.push(marker);
            var content = "<p>" + stages[stage].sp_name + "</p>";
            addInfoWindow(marker, content);
        }
        addLegend();

    } catch (e) {
        console.log(e);
    }
}

function addLegend() {
    var legend = document.createElement('div');
    legend.id = 'legend';
    var pick = document.createElement('div');
    pick.innerHTML = '<img src="<%=asset_path "pick.png"%>"> ' + '<span>Boarding Point</span>';
    legend.appendChild(pick);
    var drop = document.createElement('div');
    drop.innerHTML = '<img src="<%=asset_path "drop.png"%>"> ' + '<span>Dropping Point';
    legend.appendChild(drop);
    map.controls[google.maps.ControlPosition.LEFT_BOTTOM].push(legend);
}

function downloadApp() {
    if (!navigator.userAgent.match(/(iPad|iPhone|iPod)/g))
        window.open(journeyDetails.android_app_url, '_system', 'location=yes');
    else if (navigator.userAgent.match(/(iPad|iPhone|iPod)/g)) {
        window.open(journeyDetails.ios_app_url, '_system', 'location=yes');
    }
}

function getStageIcon(point) {
    if (point.skipped) return 'fa fa-times';
    if (point.id == etaDetails.last_dropoff_id) return 'fa fa-stop-circle'

    return 'fa fa-check';
}

function getStageIcon_pickup(point) {
    if (point.skipped) return 'fa fa-times';
    if (point.id == etaDetails.last_crossed_pickup) return 'fa fa-stop-circle'

    return 'fa fa-check';
}

function getDescText(point, i) {
    if (i == 0 && i == firstLoad) {
        if (point.departure_time)
            return 'First Boarding point Left at ' + point.departure_time + getBusDelayTime(point.delay_time);
        else
            return 'First Boarding point Scheduled at ' + point.scheduled_time;
    }
    if (i == etaDetails.eta_map_data.length - 1 && i == firstLoad) {
        return 'Reached at ' + point.arrival_time + getBusDelayTime(point.delay_time);
    }
    if (point.skipped) {
        return 'Skipped';
    }
    if (i == firstLoad && !etaDetails.is_passed) {
        return 'Arrived at ' + (point.arrival_time ? point.arrival_time : point.scheduled_time);
    }
    if (i <= firstLoad) {
        if (point.departure_time)
            return 'Left at ' + point.departure_time + getBusDelayTime(point.delay_time);
        if (point.arrival_time)
            return 'Arrived at ' + point.arrival_time + getBusDelayTime(point.delay_time);
        else
            return 'Skipped';
    } else {
        return 'Scheduled at ' + point.scheduled_time;
    }
}

function getDescText_pickup(point, i) {
    if (i == 0 && i == firstLoad_pickup) {
        if (point.departure_time)
            return 'First Boarding point Left at ' + point.departure_time + getBusDelayTime(point.delay_time);
        else
            return 'First Boarding point Scheduled at ' + point.scheduled_time;
    }
    if (i == etaDetails.eta_pickup_data.length - 1 && i == firstLoad_pickup) {
        return 'Reached at ' + point.arrival_time + getBusDelayTime(point.delay_time);
    }
    if (point.skipped) {
        return 'Skipped';
    }
    if (i == firstLoad_pickup && !etaDetails.is_passed) {
        return 'Arrived at ' + (point.arrival_time ? point.arrival_time : point.scheduled_time);
    }
    if (i <= firstLoad_pickup) {
        if (point.departure_time)
            return 'Left at ' + point.departure_time + getBusDelayTime(point.delay_time);
        if (point.arrival_time)
            return 'Arrived at ' + point.arrival_time + getBusDelayTime(point.delay_time);
        else
            return 'Skipped';
    } else {
        return 'Scheduled at ' + point.scheduled_time;
    }
}

function getBusDelayTime(delay) {

    if (delay) {
        var time = ''
        var hours = Math.trunc(Math.abs(delay) / 60);
        if (hours > 0) time = hours + ' hr'
        var minutes = Math.abs(delay) % 60;
        if (minutes > 0) time += minutes + ' mins'
        //return time;
        if (delay > 0) {
            return ' Delayed by ' + time;
        } else if (delay < 0) {
            return ' Running early by ' + time;
        } else {
            return ' Running as scheduled';
        }
    } else {
        return ' Running as scheduled';
    }
}
function isMarkerInBounds() {
    var mapBounds = new google.maps.LatLngBounds(map.getBounds().getSouthWest(),
        map.getBounds().getNorthEast());
    return mapBounds.contains(busMarker.getPosition());
};


function googleMapButton(className) {

    var controlDiv = document.createElement("div");
    controlDiv.className = className;
    controlDiv.index = 1;
    controlDiv.style.padding = "10px";
    // set CSS for the control border.
    var controlUi = document.createElement("div");
    controlUi.style.backgroundColor = "rgb(255, 255, 255)";
    controlUi.style.color = "#565656";
    controlUi.style.cursor = "pointer";
    controlUi.style.textAlign = "center";
    controlUi.style.boxShadow = "rgba(0, 0, 0, 0.298039) 0px 1px 4px -1px";
    controlDiv.appendChild(controlUi);
    // set CSS for the control interior.
    var controlImg = document.createElement("img");
    controlImg.id = 'fullScreen';
    controlImg.style.padding = "4px";
    controlImg.style.paddingBottom = "2px";
    controlImg.width = 24;
    controlImg.src = "<%=asset_path "full_screen.png"%>"
    controlUi.appendChild(controlImg);

    return controlDiv;
}

function FullScreenControl(map) {

    var controlDiv = googleMapButton("fullScreen");
    var interval;
    var fullScreen = false;
    var mapDiv = map.getDiv();
    var divStyle = mapDiv.style;
    if (mapDiv.runtimeStyle) {
        divStyle = mapDiv.runtimeStyle;
    }
    var originalPos = divStyle.position;
    var originalWidth = divStyle.width;
    var originalHeight = divStyle.height;
    // ie8 hack
    if (originalWidth === "") {
        originalWidth = mapDiv.style.width;
    }
    if (originalHeight === "") {
        originalHeight = mapDiv.style.height;
    }
    var originalTop = divStyle.top;
    var originalLeft = divStyle.left;
    var originalZIndex = divStyle.zIndex;
    var bodyStyle = document.body.style;
    var boby = document.body;
    if (boby.runtimeStyle) {
        bodyStyle = boby.runtimeStyle;
    }
    var originalOverflow = bodyStyle.overflow;
    controlDiv.goFullScreen = function () {
        mapDiv.style.position = "fixed";
        mapDiv.style.width = "100%";
        mapDiv.style.height = "100%";
        mapDiv.style.top = "0";
        mapDiv.style.left = "0";
        mapDiv.style.zIndex = "100";
        document.body.style.overflow = "hidden";
        var ele = document.getElementById('fullScreen');
        if (ele) ele.src = "<%=asset_path "exit_full_screen.png"%>";
        mapView = 'maximized'
        fullScreen = true;
        google.maps.event.trigger(map, "resize");
        if (busMarker) {
            var latLng = busMarker.getPosition(); // returns LatLng object
            map.setCenter(latLng);
        }
        poly.setOptions({
            strokeWeight: 7
        })
        setTimeout(function () {
            addmarkers();
            var map_options = {
                draggable: true,
                zoomControl: true,
                scrollwheel: true,
                disableDoubleClickZoom: false,
                panControl: true,
                mapTypeControl: true,
                scaleControl: true,
                streetViewControl: true,
                overviewMapControl: true,
                rotateControl: true,
                clickableIcons: true,
                fullscreenControl: false

            };
            map.setOptions(map_options);
        }, 500)
        // this works around street view causing the map to disappear, which is caused by Google Maps setting the
        // css position back to relative. There is no event triggered when Street View is shown hence the use of setInterval
        interval = setInterval(function () {
            if (mapDiv.style.position !== "fixed") {
                mapDiv.style.position = "fixed";
                google.maps.event.trigger(map, "resize");
            }
        }, 100);
    };
    controlDiv.exitFullScreen = function () {
        if (originalPos === "") {
            mapDiv.style.position = "relative";
        } else {
            mapDiv.style.position = originalPos;
        }
        mapDiv.style.width = originalWidth;
        mapDiv.style.height = originalHeight;
        mapDiv.style.top = originalTop;
        mapDiv.style.left = originalLeft;
        mapDiv.style.zIndex = originalZIndex;
        document.body.style.overflow = originalOverflow;
        var ele = document.getElementById('fullScreen');
        if (ele) ele.src = "<%=asset_path "full_screen.png"%>";
        fullScreen = false;
        mapView = 'minimized'
        google.maps.event.trigger(map, "resize");
        var map_options = {
            zoom: 14,
            draggable: false,
            panControl: false,
            zoomControl: false,
            scrollwheel: false,
            mapTypeControl: false,
            scaleControl: false,
            streetViewControl: false,
            overviewMapControl: false,
            rotateControl: false,
            disableDoubleClickZoom: true,
            clickableIcons: false,
            fullscreenControl: false
        };
        poly.setOptions({
            strokeWeight: 0
        })
        map.setOptions(map_options);
        clearMap();
        if (busMarker)
            map.setCenter(busMarker.getPosition());
        clearInterval(interval);
    };
    // setup the click event listener
    google.maps.event.addDomListener(controlDiv, "click", function () {
        if (!fullScreen) {
            controlDiv.goFullScreen();
        } else {
            controlDiv.exitFullScreen();
        }
    });
    return controlDiv;
}

function mapViewChange() {
    google.maps.event.addListener(map, 'bounds_changed', function () {
        try {
            var mapEle = document.getElementsByClassName('gm-style');
            if (mapEle[0].clientHeight == window.innerHeight &&
                mapEle[0].clientWidth == window.innerWidth) {
                if (mapView != 'minimized') return;
                var map_options = {
                    //zoom: 5,
                    //maxZoom: 15,
                    draggable: true,
                    zoomControl: true,
                    scrollwheel: true,
                    disableDoubleClickZoom: false,
                    panControl: true,
                    mapTypeControl: true,
                    scaleControl: true,
                    streetViewControl: true,
                    overviewMapControl: true,
                    rotateControl: true,
                    clickableIcons: true

                };
                map.setOptions(map_options);
                mapView = 'maximized';
                if (busMarker) {
                    var latLng = busMarker.getPosition(); // returns LatLng object
                    map.setCenter(latLng);
                }
                poly.setOptions({
                    strokeWeight: 7
                })
                addmarkers();
            }
            else {
                if (mapView == 'minimized') return;
                var map_options = {
                    zoom: 14,
                    draggable: false,
                    panControl: false,
                    zoomControl: false,
                    scrollwheel: false,
                    mapTypeControl: false,
                    scaleControl: false,
                    streetViewControl: false,
                    overviewMapControl: false,
                    rotateControl: false,
                    disableDoubleClickZoom: true,
                    clickableIcons: false
                };
                poly.setOptions({
                    strokeWeight: 0
                })
                map.setOptions(map_options);
                mapView = 'minimized'
                clearMap();
            }
        } catch (e) {
        }
    });
}

function getDirections() {
    if (journeyDetails.lat_long)
        window.open("https://www.google.com/maps/dir/?api=1&origin=&destination=" + journeyDetails.lat_long[0] + "," + journeyDetails.lat_long[1]);
    else {
        showToast('something went wrong, please try again');
    }
}

function requestChange() {
    downConfirm();
}

function scrollETA() {
    var ele = document.getElementById('current-loc');
    if (ele) {
        scrollLeftAnimate(ele.parentElement, ((window.innerWidth > 0) ? window.innerWidth : screen.width / 2), 1000);
    }
}

function scrollLeftAnimate(element, to, duration) {
    var ele = element.parentElement.parentElement;
    if (duration <= 0) return;
    var difference = element.offsetLeft - to;
    var perTick = (difference / duration * 10);
    perTick = perTick > 1 ? perTick : difference;


    setTimeout(function () {
        ele.scrollLeft = ele.scrollLeft + perTick;
        if (ele.scrollLeft >= difference) return;
        scrollLeftAnimate(element, to, duration - 10);
    }, 10);
}

function submitFeed(params, modal) {
    try {
        document.getElementById('loader').classList.add('loading');
        URL = 'http://bus.trackingo.in/api/live//tracking_feedback?key=' + shortKey;  //Your URL
        var xhr = new XMLHttpRequest();
        xhr.open("POST", URL, true);
        xhr.setRequestHeader("Content-type", "application/json");
        xhr.onload = function (e) {

            if (xhr.readyState === 4) {
                document.getElementById('loader').classList.remove('loading');
                if (xhr.status === 200) {

                    var jsonRes = JSON.parse(xhr.responseText);
                    console.log(jsonRes);
                    if (jsonRes.status == 200) {
                        closeModal(modal);
                        showToast(jsonRes.message);
                    } else {
                        showToast(jsonRes.message);
                    }

                } else {
                    showToast('something went wrong, please try again');
                }
            }

        };
        xhr.onerror = function (e) {
            console.error(e.statusText);
            document.getElementById('loader').classList.remove('loading');
            showToast('something went wrong, please try again');
        };
        xhr.send(JSON.stringify(params));
    } catch (e) {
        console.log('crash');
        showToast('something went wrong, please try again');
        document.getElementById('loader').classList.remove('loading');
    }
}

function showToast(message) {
    // Get the snackbar DIV
    var toast = document.getElementById("snackbar")
    toast.innerText = message;
    // Add the "show" class to DIV
    toast.className = "show";

    // After 3 seconds, remove the show class from DIV
    setTimeout(function () { toast.className = toast.className.replace("show", ""); }, 1500);
}
function downConfirm() {
    if (confirm("It’s great to have you onboard. Check out the trending features, just a click away.") == true) {
        downloadApp();
    }
}

    L.interpolatePosition = function(p1, p2, duration, t) {
    var k = t/duration;
    k = (k > 0) ? k : 0;
    k = (k > 1) ? 1 : k;
    return L.latLng(p1.lat + k * (p2.lat - p1.lat),
        p1.lng + k * (p2.lng - p1.lng));
};

L.Marker.MovingMarker = L.Marker.extend({

    //state constants
    statics: {
        notStartedState: 0,
        endedState: 1,
        pausedState: 2,
        runState: 3
    },

    options: {
        autostart: false,
        loop: false,
    },

    initialize: function (latlngs, durations, options) {
        L.Marker.prototype.initialize.call(this, latlngs[0], options);

        this._latlngs = latlngs.map(function(e, index) {
            return L.latLng(e);
        });

        if (durations instanceof Array) {
            this._durations = durations;
        } else {
            this._durations = this._createDurations(this._latlngs, durations);
        }

        this._currentDuration = 0;
        this._currentIndex = 0;

        this._state = L.Marker.MovingMarker.notStartedState;
        this._startTime = 0;
        this._startTimeStamp = 0;  // timestamp given by requestAnimFrame
        this._pauseStartTime = 0;
        this._animId = 0;
        this._animRequested = false;
        this._currentLine = [];
        this._stations = {};
    },

    isRunning: function() {
        return this._state === L.Marker.MovingMarker.runState;
    },

    isEnded: function() {
        return this._state === L.Marker.MovingMarker.endedState;
    },

    isStarted: function() {
        return this._state !== L.Marker.MovingMarker.notStartedState;
    },

    isPaused: function() {
        return this._state === L.Marker.MovingMarker.pausedState;
    },

    start: function() {
        if (this.isRunning()) {
            return;
        }

        if (this.isPaused()) {
            this.resume();
        } else {
            this._loadLine(0);
            this._startAnimation();
            this.fire('start');
        }
    },

    resume: function() {
        if (! this.isPaused()) {
            return;
        }
        // update the current line
        this._currentLine[0] = this.getLatLng();
        this._currentDuration -= (this._pauseStartTime - this._startTime);
        this._startAnimation();
    },

    pause: function() {
        if (! this.isRunning()) {
            return;
        }

        this._pauseStartTime = Date.now();
        this._state = L.Marker.MovingMarker.pausedState;
        this._stopAnimation();
        this._updatePosition();
    },

    stop: function(elapsedTime) {
        if (this.isEnded()) {
            return;
        }

        this._stopAnimation();

        if (typeof(elapsedTime) === 'undefined') {
            // user call
            elapsedTime = 0;
            this._updatePosition();
        }

        this._state = L.Marker.MovingMarker.endedState;
        this.fire('end', {elapsedTime: elapsedTime});
    },

    addLatLng: function(latlng, duration) {
        this._latlngs.push(L.latLng(latlng));
        this._durations.push(duration);
    },

    moveTo: function(latlng, duration) {
        this._stopAnimation();
        this._latlngs = [this.getLatLng(), L.latLng(latlng)];
        this._durations = [duration];
        this._state = L.Marker.MovingMarker.notStartedState;
        this.start();
        this.options.loop = false;
    },

    addStation: function(pointIndex, duration) {
        if (pointIndex > this._latlngs.length - 2 || pointIndex < 1) {
            return;
        }
        this._stations[pointIndex] = duration;
    },

    onAdd: function (map) {
        L.Marker.prototype.onAdd.call(this, map);

        if (this.options.autostart && (! this.isStarted())) {
            this.start();
            return;
        }

        if (this.isRunning()) {
            this._resumeAnimation();
        }
    },

    onRemove: function(map) {
        L.Marker.prototype.onRemove.call(this, map);
        this._stopAnimation();
    },

    _createDurations: function (latlngs, duration) {
        var lastIndex = latlngs.length - 1;
        var distances = [];
        var totalDistance = 0;
        var distance = 0;

        // compute array of distances between points
        for (var i = 0; i < lastIndex; i++) {
            distance = latlngs[i + 1].distanceTo(latlngs[i]);
            distances.push(distance);
            totalDistance += distance;
        }

        var ratioDuration = duration / totalDistance;

        var durations = [];
        for (i = 0; i < distances.length; i++) {
            durations.push(distances[i] * ratioDuration);
        }

        return durations;
    },

    _startAnimation: function() {
        this._state = L.Marker.MovingMarker.runState;
        this._animId = L.Util.requestAnimFrame(function(timestamp) {
            this._startTime = Date.now();
            this._startTimeStamp = timestamp;
            this._animate(timestamp);
        }, this, true);
        this._animRequested = true;
    },

    _resumeAnimation: function() {
        if (! this._animRequested) {
            this._animRequested = true;
            this._animId = L.Util.requestAnimFrame(function(timestamp) {
                this._animate(timestamp);
            }, this, true);
        }
    },

    _stopAnimation: function() {
        if (this._animRequested) {
            L.Util.cancelAnimFrame(this._animId);
            this._animRequested = false;
        }
    },

    _updatePosition: function() {
        var elapsedTime = Date.now() - this._startTime;
        this._animate(this._startTimeStamp + elapsedTime, true);
    },

    _loadLine: function(index) {
        this._currentIndex = index;
        this._currentDuration = this._durations[index];
        this._currentLine = this._latlngs.slice(index, index + 2);
    },

    /**
     * Load the line where the marker is
     * @param  {Number} timestamp
     * @return {Number} elapsed time on the current line or null if
     * we reached the end or marker is at a station
     */
    _updateLine: function(timestamp) {
        // time elapsed since the last latlng
        var elapsedTime = timestamp - this._startTimeStamp;

        // not enough time to update the line
        if (elapsedTime <= this._currentDuration) {
            return elapsedTime;
        }

        var lineIndex = this._currentIndex;
        var lineDuration = this._currentDuration;
        var stationDuration;

        while (elapsedTime > lineDuration) {
            // substract time of the current line
            elapsedTime -= lineDuration;
            stationDuration = this._stations[lineIndex + 1];

            // test if there is a station at the end of the line
            if (stationDuration !== undefined) {
                if (elapsedTime < stationDuration) {
                    this.setLatLng(this._latlngs[lineIndex + 1]);
                    return null;
                }
                elapsedTime -= stationDuration;
            }

            lineIndex++;

            // test if we have reached the end of the polyline
            if (lineIndex >= this._latlngs.length - 1) {

                if (this.options.loop) {
                    lineIndex = 0;
                    this.fire('loop', {elapsedTime: elapsedTime});
                } else {
                    // place the marker at the end, else it would be at
                    // the last position
                    this.setLatLng(this._latlngs[this._latlngs.length - 1]);
                    this.stop(elapsedTime);
                    return null;
                }
            }
            lineDuration = this._durations[lineIndex];
        }

        this._loadLine(lineIndex);
        this._startTimeStamp = timestamp - elapsedTime;
        this._startTime = Date.now() - elapsedTime;
        return elapsedTime;
    },

    _animate: function(timestamp, noRequestAnim) {
        this._animRequested = false;

        // find the next line and compute the new elapsedTime
        var elapsedTime = this._updateLine(timestamp);

        if (this.isEnded()) {
            // no need to animate
            return;
        }

        if (elapsedTime != null) {
             // compute the position
            var p = L.interpolatePosition(this._currentLine[0],
                this._currentLine[1],
                this._currentDuration,
                elapsedTime);
            this.setLatLng(p);
        }

        if (! noRequestAnim) {
            this._animId = L.Util.requestAnimFrame(this._animate, this, false);
            this._animRequested = true;
        }
    }
});

L.Marker.movingMarker = function (latlngs, duration, options) {
    return new L.Marker.MovingMarker(latlngs, duration, options);
};

<% if false %>
$(document).ready(function(){
var r=confirm("We have launched a Cool App for better Tracking Experience. \n\n Please click on OK to download the App from Playstore.");
   if (r==true)
   {
     document.location.href = "https://play.google.com/store/apps/details?id=com.bitla.customertrackingo";
   }
   else
   {
    return false;
   }
});
<% end %>